

<script>
    import InputComponent from './InputComponent.vue';
    import TaskComponent from './TaskComponent.vue';
    import ModalComponent from './ModalComponent.vue';

    export default {
        components: { TaskComponent, InputComponent, ModalComponent },

        data: () => ({
            tasks: [],
            newTask: '',
            modal: false,
            current: ''
        }),
        methods: {
            addNewTask(){
                if ( this.newTask === '') {
                    this.$refs.input.showError = true;
                } else {
                    this.tasks.push({
                        name: this.newTask,
                        state: false,
                    });
                    this.updateData();
                    this.$refs.input.showError = false;
                    this.newTask = '';
                }
            },
            editTask(index) {
                this.tasks[index].state = true;
                this.updateData();
            },
            deleteTask(task, index){
                if ( task.state ) {
                    this.tasks.splice(index, 1);
                    this.updateData();   
                } else {
                    this.current = index;
                    this.modal = true;
                }
            },
            forceDelete(){
                this.tasks.splice(this.current, 1);
                this.updateData();
                this.modal = false;
            },
            updateData(){
                localStorage.setItem('data-to-do', JSON.stringify(this.tasks));
            },
            getData(){
                let dataToDo = JSON.parse(localStorage.getItem('data-to-do'))

                if ( dataToDo === null) {
                    this.tasks = [];
                } else {
                    this.tasks = dataToDo;
                }
            }
        },
        created (){
            this.getData();
        }
    }
</script>
<template>
    <div class="content-to-do pt-10">
        <div class="container container--my-project">
            <h2 class="tx-36 tx-uppercase opacity-90 mb-10">
                Tareas por hacer
            </h2>

            <div class="flex align-end mb-10">
                <!-- INPUT -->
                <input-component label="NUEVA TAREA" v-model="newTask" ref="input" errorMessage="Favor de escribir una tarea"/>

                <!-- SUBMIT -->
                <button class="btn btn--primary h-9 ml-3" @click="addNewTask()">
                    AGREGAR
                </button>
            </div>

            <!-- TASK LIST -->
            <p class="mt-20 opacity-60" v-if="tasks.length === 0">
                Agrega tu primer tarea
            </p>

            <div v-else>
                <task-component v-for="(task, index) of tasks" :key="index" :task="task" :index="index" @editTask="editTask(index)" @deleteTask="deleteTask(task, index)"/>
            </div>
        </div>

        <!-- MODAL -->
        <transition name="fade">
            <modal-component v-show="modal" @close="modal = false" @forceDelete="forceDelete()"></modal-component>
        </transition>

    </div>
</template>